/*
 * strcspn.c  -  String handling which should be in the standard library
 *
 * Copyright (C) 2003-2007 Gero Kuhlmann <gero@gkminix.han.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: strcspn.c,v 1.8 2007/01/06 18:31:39 gkminix Exp $
 */

#include <common.h>
#include <nblib.h>
#include "privlib.h"



/*
 * Return the length of the initial segment of a string, which consists
 * entirely of characters not in REJECT.
 */
int nbstrcspn __F((str, reject), const char *str AND const char *reject)
{
  char *cp;
  int i = 0;

  if (str != NULL && reject != NULL)
	for (cp = str; *cp; i++, cp++)
		if (strchr(reject, *cp) != NULL)
			break;
  return(i);
}

